Attribute VB_Name = "ProjectFunctions"
'*
'*  MODULE INFORMATION
'*
'*  File name     : ProjectFunctions.bas
'*
'*  Date          : 15/Sep/2005
'*  Programmer    : MBevan
'*
'*  Description   : Misc functions for the axSPC_Sample application.
'*
'*
'*  Comments      : Most (if not all) functions here could have easily been included in the frmMain module
'*                  However, to minimize the amount of "noise" in the sample code, code not relevant
'*                  to the operation of the axSPC control was moved here out of the way. Note that
'*                  better error handling is included here because this code really doesn't need to
'*                  be referenced. With that being said, if there is something useful to you in this
'*                  code, feel free to use it.
            

Option Explicit

'******************************************
'* This function loads the Subgroup combo box with the correct available values
'* Input:      None
'* Output:     None
'* Programmer: MBevan
'* Date:       15/Sep/2005
'******************************************
Public Sub LoadSubGroupComboBox(ByRef comboSubGroup As ComboBox)
Dim i As Integer
Dim n_strMessage As String

On Error GoTo EH_LoadSubGroupComboBox

For i = 1 To 20
    comboSubGroup.AddItem i
Next i

NormalExit_LoadSubGroupComboBox:
    On Error GoTo 0
    Exit Sub

EH_LoadSubGroupComboBox:
    n_strMessage = "Function ProjectFunctions::LoadSubGroupComboBox failed with error: " & vbCrLf & Error()
    Call MsgBox(n_strMessage, vbOKOnly + vbCritical, "System Message")
    Err.Clear
    Resume NormalExit_LoadSubGroupComboBox

End Sub

'******************************************
'* This function loads the sensitivity list box with the correct available values
'* Input:      None
'* Output:     None
'* Programmer: MBevan
'* Date:       15/Sep/2005
'******************************************
Public Sub LoadSensitivityListBox(lstSensitivity As ListBox)
Dim i As Integer
Dim m_strDetectionPeriodString(3) As String, n_strMessage As String

On Error GoTo EH_LoadSensitivityListBox

m_strDetectionPeriodString(0) = "Low (Detection Rules 1 and 4)"
m_strDetectionPeriodString(1) = "Medium (Detection Rules 1,2, and 4)"
m_strDetectionPeriodString(2) = "High (Detection Rules 1,2,3, and 4)"

For i = 0 To 2
    lstSensitivity.AddItem m_strDetectionPeriodString(i)
Next i

NormalExit_LoadSensitivityListBox:
    On Error GoTo 0
    Exit Sub

EH_LoadSensitivityListBox:
    n_strMessage = "Function ProjectFunctions::LoadSensitivityListBox failed with error: " & vbCrLf & Error()
    Call MsgBox(n_strMessage, vbOKOnly + vbCritical, "System Message")
    Err.Clear
    Resume NormalExit_LoadSensitivityListBox

End Sub
Public Sub LoadDefaultDataValues(ByRef txtBox As TextBox)
Dim n_strData As String

n_strData = "-0.0076,0.0006,-0.0033,0.0002,0.0055,-0.0021,0.0041,0.0063,-0.0052,0.0028,-0.0054,"
n_strData = n_strData & "-0.0003,0.0004,0.0033,-0.0006,-0.0008,-0.0038,-0.0033,0.0029,0.0008,"
n_strData = n_strData & "-0.0031,0.0016,-0.0001,0.0014,-0.002"

txtBox.Text = ConvertStringDelimiter(True, n_strData)

End Sub

'Convert the delimter in a string from either a comma to a carriage return, or vice versa.
Public Function ConvertStringDelimiter(bCommaToCR As Boolean, strData As String) As String
Dim n_strConvertedString As String, n_strMessage As String

On Error GoTo EH_ConvertStringDelimiter
n_strConvertedString = ""

If bCommaToCR Then
    n_strConvertedString = Replace(strData, ",", vbCrLf, 1, -1, vbTextCompare)
Else
    n_strConvertedString = Replace(strData, vbCrLf, ",", 1, -1, vbTextCompare)
End If

NormalExit_ConvertStringDelimiter:
    ConvertStringDelimiter = n_strConvertedString
    On Error GoTo 0
    Exit Function
    
EH_ConvertStringDelimiter:
    n_strMessage = "Function ProjectFunctions::ConvertStringDelimiter failed with error: " & vbCrLf & Error()
    Call MsgBox(n_strMessage, vbOKOnly + vbCritical, "System Message")
    Err.Clear
    GoTo NormalExit_ConvertStringDelimiter
    
End Function

